Package: ggraptR
Type: Package
Title: Allows Interactive Visualization of Data Through a Web Browser
        GUI
Version: 1.3
Authors@R: 
    c(person("Eugene", "Dubossarsky", role=c("aut", "cph", "cre"),
             email="eugene@presciient.com"),
	     person("Julius", "Neggo", role="ctb", comment="Lead Developer"),
	     person("Howard", "Song", role="aut", comment="Developer"),
	     person("Susan", "Wang", role="ctb", comment="Project Manager"),
	     person("Jason", "Widjaja", role="ctb", comment="Vignette"),
	     person("Jose", "Magana", role="ctb", comment="Package Manager and Developer"),
	     person("Sergey", "Skripko", role="ctb", comment="Developer"))
Description: Intended for both technical and non-technical users to create
    interactive data visualizations through a web browser GUI without writing any
    code.
License: GPL (>= 2)
Suggests: knitr, markdown
Depends: dplyr (>= 0.7.5), ggplot2 (>= 2.2.0), pacman (>= 0.4.6),
        purrr(>= 0.2.4), shiny (>= 0.12.2)
BugReports: https://github.com/cargomoose/raptR/issues
VignetteBuilder: knitr
RoxygenNote: 6.0.1
NeedsCompilation: no
Packaged: 2020-06-24 01:11:17 UTC; juliux
Author: Eugene Dubossarsky [aut, cph, cre],
  Julius Neggo [ctb] (Lead Developer),
  Howard Song [aut] (Developer),
  Susan Wang [ctb] (Project Manager),
  Jason Widjaja [ctb] (Vignette),
  Jose Magana [ctb] (Package Manager and Developer),
  Sergey Skripko [ctb] (Developer)
Maintainer: Eugene Dubossarsky <eugene@presciient.com>
Repository: CRAN
Date/Publication: 2020-06-24 05:00:03 UTC
Built: R 4.6.0; ; 2026-04-29 03:13:59 UTC; unix

# ggraptR
[![](http://cranlogs.r-pkg.org/badges/ggraptR)](https://CRAN.R-project.org/package=ggraptR)

Rapid and Pretty Things in R : A shiny graphical user interface for your favourite ggplot graphics in R

![demo](inst/ggraptR/www/demo.gif)

## Installation  
``` 
install.packages('ggraptR', dependencies=TRUE)
```

curDatasetPlotInputs <- reactive({
  getDefinedPlotInputs(length(numericVars()), length(categoricalVars()))
})

separatePlotInputs <- reactive({
  if (is.null(plotTypes()) || is.null(curDatasetPlotInputs())) return()
  inputs <- lapply(plotTypes(), function(pType) {
    flattenList(isolate(curDatasetPlotInputs()))[[pType]]
  })
  names(inputs) <- plotTypes()
  inputs
})

plotInputs <- reactive({
  unique(unlist(separatePlotInputs()))
})


# to make some numeric features with low n of unique values categorical
nCatUniqVals <- reactive({
  if (is.null(input$nCatUniqVals)) 6 else input$nCatUniqVals
})

# variables for dataset() -- raw or manually aggregated dataset
categoricalVars <- reactive({
  if (is.null(dataset())) return()
  n_uniq_thresh <- isolate(nCatUniqVals())
  rearValFeatures <- getVarNamesUniqValsCntLOEN(dataset(), n_uniq_thresh)
  unique(c(getIsFactorVarNames(dataset()), rearValFeatures))
})

numericVars <- reactive({
  if (is.null(dataset())) return()
  res <- setdiff(colnames(dataset()), categoricalVars())
  if (length(res) != 0) res
})

plotTypesWarn <- reactive({
  if (is.null(dataset())) return()
  n_num <- length(numericVars())
  n_cat <- length(categoricalVars())
  if (n_num == 0) {
    return('Can not draw any plot when number of detected numeric features == 0')
  }
  problem <- if (n_num == 1) {
    'number of detected numeric features == 1' 
  } else if (n_cat == 0) {
    'number of detected categorical features == 0' 
  }
  if (!is.null(problem)) paste('Not all plot types are available for the dataset with',
                               problem)
})

# variables for aggDf()
aggDfFactorVars <- reactive({
  dataset <- aggDf()
  if (!is.null(dataset)) {
    getIsFactorVarNames(dataset)
  }
})

aggDfNumericVars <- reactive({
  dataset <- aggDf()
  if (!is.null(dataset)) {
    getIsNumericVarNames(dataset)
  }
})


# facets
facetWidgetsLoaded <- reactive({
  !any(sapply(c('facetCol', 'facetRow', 'facetWrap','facetScale'), 
              function(widget) is.null(input[[widget]])))
})

isFacetSelected <- reactive({
  if (!facetWidgetsLoaded()) return(F)
  facetFam <- c(facetCol(), facetRow(), facetWrap())
  !(facetFam[1] %in% c('None', '', '.') && length(unique(facetFam)) == 1)
})

facetGridSelected <- reactive({
  facetWidgetsLoaded() && any(c(facetCol(), facetRow()) != '.')
})

facetWrapSelected <- reactive({
  facetWidgetsLoaded() && facetWrap() != '.'
})



# reactive that returns a value "discrete" or "continuous"
xType <- reactive({
  dataset <- aggDf()
  if (!is.null(dataset) && !is.null(x())) {
    if (x() %in% aggDfNumericVars()) 'continuous' else 'discrete'
  }
})


# reactive that returns a value "discrete" or "continuous"
yType <- reactive({
  dataset <- aggDf()
  if (!is.null(dataset) && 'y' %in% plotInputs() && !is.null(y())) {
    if (y() %in% aggDfNumericVars()) 'continuous' else 'discrete'
  }
})

# reactive that returns a value "discrete" or "continuous"
colorType <- reactive({
  dataset <- aggDf()
  if (!is.null(dataset) && !is.null(color())) {
    if (color() %in% aggDfNumericVars()) 'continuous' else 'discrete'
  } else 'none'
})

# conditional reactive: semi-automatic aggregation is on
semiAutoAggOn <- reactive({
  !is.null(plotAggMeth()) && tolower(plotAggMeth()) != 'none'
})

# this function renames column names of aggregate df
renameAggColNames <- function(df, aggBy, aggTarget, aggMeth) {
  cntInAggMeth <- 'count' %in% aggMeth
  aggMeth <- setdiff(aggMeth, 'count')
  
  colnames <- c(aggBy)
  for (meth in aggMeth) {
    for (targ in aggTarget) {
      colname <- paste(targ, meth, sep='_')
      colnames <- c(colnames, colname)
    }
  }

  if (cntInAggMeth) {
    colnames <- c(colnames, 'count')
  }
  
  colnames(df) <- colnames
  return(df)
}

# this function aggregates raw data using functions from dplyr
aggregate <- function(df, aggBy, aggTarget, aggMeth, nRndDeci=2) {
  # aggBy can contain duplicates when x and facet variables are the same
  aggBy <- unique(aggBy)
  
  # filter non-na entries by target and select valuable variables
  df <- df[apply(df, 1, function(x) all(!is.na(x))), c(aggBy, aggTarget)]

  # conditional to perform count later
  cntInAggMeth <- 'count' %in% aggMeth
  
  # conditional to perform median later
  medInAggMeth <- 'median' %in% aggMeth

  # select non-problematic aggregation methods
  aggMeth <- setdiff(aggMeth, c('count', 'median'))

  # convert character vector to list of symbols
  dots <- lapply(aggBy, as.symbol)

  # group data
  grp <- group_by_(df, .dots=dots)

  agg <- NULL
  if (length(aggMeth) != 0) {
    # perform non-problematic aggregation by column
    agg <- summarise_each(grp, aggMeth)
    
    # convert to data frame
    agg <- as.data.frame(agg)
    
    # rename column names
    agg <- renameAggColNames(agg, aggBy, aggTarget, aggMeth)
  }

  # attach aggregate counts if requested
  if (cntInAggMeth) {
    cnt <- summarise(grp, count=n())
    if (is.null(agg))
      agg <- cnt
    else
      agg$count <- cnt$count
  }

  # perform median aggregation by column
  if (medInAggMeth) {
    # https://github.com/hadley/dplyr/issues/1824
    medAgg <- summarise_each(grp, funs('median'))
    nMedAggCol <- length(aggBy)
    ncol <- ncol(medAgg)
    colnames(medAgg) <- c(aggBy, paste0(colnames(medAgg)[(nMedAggCol+1):ncol], '_median'))
    if (is.null(agg))
      agg <- medAgg
    else
      agg <- merge(agg, medAgg, by=aggBy)
  }

  # find numeric columns and round
  numericVars <- getIsNumericVarNames(agg)

  for (numericVar in numericVars) {
    agg[[numericVar]] <- round(agg[[numericVar]], nRndDeci)
  }
  
  agg
}

# this function calculates share percentage (or relative frequency)
calcShare <- function(df, shareOf, shareTarget, nRndDeci=2, displayPerc=TRUE) {
  # calculate share if necessary
  if (is.null(df) | is.null(shareOf) | is.null(shareTarget)) {return(df)}
  
  colnames <- colnames(df)
  if (!(shareOf %in% colnames) | !(shareTarget %in%colnames)) {return(df)}

  dots <- lapply(shareOf, as.symbol)
  grp <- group_by_(df, .dots=dots)
  agg <- summarise_(grp, sum = sprintf('sum(%s)', shareTarget))
  agg <- as.data.frame(agg)
  df <- merge(df, agg, by=shareOf)

  df$share <- df[[shareTarget]] / df$sum
  df$sum <- NULL
  
  if (displayPerc) {
    df$share <- round(df$share * 100, nRndDeci)
    df$share <- paste(as.character(df$share), '%')
  } else {
    df$share <- round(df$share, nRndDeci)
  }

  return(df)
}

verticalLayout(
  fluidRow(
    column(6,
           uiOutput('facetRowCtrl')
    ),
    column(6,
           uiOutput('facetColCtrl')
    )
  ),
  
  fluidRow(
    column(6,
           uiOutput('facetWrapCtrl')
    ),
    column(6,
           uiOutput('facetScaleCtrl')
    )
  )  
)

# plot options
verticalLayout(
  div(
    uiOutput('plotTypesCtrl', 
             style = 'float: left; margin-right: 44px; width:-webkit-fill-available'),
    div(
      uiOutput('dlPlotOpenModalCtrl', style= 'padding-bottom: 5px;'), 
      uiOutput('pTypesWarnBtnCtrl'),  
      style='float: left; margin-left: -40px; padding-top: 25px; display: inline-block')),
  
  fluidRow(
    column(6, uiOutput('xCtrl')),
    column(6, uiOutput('yCtrl'))),
  
  uiOutput('columnsCtrl'),  # for ggpairs
  
  
  bsCollapse(id = "aesBlock", open = "Aesthetic",
             bsCollapsePanel("Aesthetic", 
                             source('./views/plotBlock/aesCtrlsUI.R', local=T)$value, 
                             style = "warning")),
  
  conditionalPanel(
    'input.plotTypes != "pairs"',
    bsCollapse(
      id = "extraPlotBlocks", open = c("Facet", "Theme", "Aggregation"), multiple=T,
      bsCollapsePanel(
        "Facet", style = "warning", 
        source('./views/plotBlock/facetCtrlsUI.R', local=T)$value),
      bsCollapsePanel(
        "Theme", style = "warning", 
        source('./views/plotBlock/labelAndStyleCtrlsUI.R', local=T)$value),
      bsCollapsePanel(
        "Aggregation", style = 'warning', 
        source('./views/plotBlock/DSTypeAndPlotAggCtrlsUI.R',local=T)$value)))
)

# dataset drop-down options 
output$datasetNameCtrl <- renderUI({
  selectInput("datasetName", "Dataset", choices=rawDatasetNames())
})

output$datasetOptionsCtrl <- renderUI({
  bsButton("datasetOptionsBtn", label=NULL, type="action", icon=icon("cog"))
})

# reactive  option
output$reactiveCtrl <- renderUI({
  checkboxInput("reactive", label="Enable reactivity", value=TRUE)
})

# upon-manual-submit button
output$submitCtrl <- renderUI({
  bsButton("submit", label="Submit", icon=icon("play-circle-o"), type="action", block=TRUE)
})

output$pTypesWarnBtnCtrl <- renderUI({
  if (is.null(plotTypesWarn())) return()
  bsButton("pTypesWarnBtn", label=NULL, icon=icon("warning"), type="action",
           style="warning")
})

output$pTypesWarnModalMessageCtrl <- renderText({
  plotTypesWarn()
})

#### code tab ####
output$plotLog <- renderText({
  paste(reactVals$log, collapse='<hr>')
})

output$evalConsoleBtn <- renderUI({
  bsButton("evalConsoleBtn", label="Evaluate", icon=icon("play-circle-o"), type="action")
})

output$consoleCtrl <- renderText({
  input$evalConsoleBtn  # dependancy
  
  isolate({
    console_input <- gsub('(?<=[^<])<-', '<<-', input$console, perl = T)
    
    assign_splitted <- strsplit(console_input, '\\s*<<-')[[1]]
    if (exists(assign_splitted[1]) && length(assign_splitted) > 1) {
      stop('This variable name has been occupied')
    }
    
    tryCatch({
      res <- capture.output(eval(parse(text = console_input)))
    }, error = function(e) {
      if (grepl('cannot change value of locked binding for', e$message)) {
        e$message <- "Did not find assigned value in .GlobalEnv"
      }
      stop(e$message)
    })
    
    paste(tryCatch({
      cat(res, fill = T)  # check renderText will be able to process it with inner cat()
      res
    }, error = function(e) {
      browser()
      if (grepl("cannot be handled by 'cat'", e$message)) {
        if (is.list(res)) str(res) else '[Success]'
      } else {
        stop(e$message)
      }
    }), collapse = '\n')
  })
})

plotGgplot <- function(dataset, inpVals) {
  pMap <- c('box'='boxplot', 'scatter'='point')
  # ensure all plots have y==T or y==F
  stopifnot(length(unique(sapply(inpVals, function(pt) is.null(pt$y)))) == 1)
  x <- if (needCatX(names(inpVals))) asFactor(inpVals[[1]]$x) else inpVals[[1]]$x
  p <- ggplot(dataset, do.call(aes_string, trimList(x=x, y=inpVals[[1]]$y)))
  
  for (lsi in 1:length(inpVals)) {
    ls <- inpVals[[lsi]]
    pType <- names(inpVals)[lsi]
    ggpType <- paste0('geom_', if (pType %in% names(pMap)) pMap[[pType]] else pType)
    need <- list(sizeMag=!is.null(ls$sizeMag) && is.null(ls$size),
                 densBlackLine=!is.null(ls$densBlackLine) && !ls$densBlackLine,
                 ..density..='density' %in% names(inpVals),
                 sepLines=pType == 'line' && 'path' %in% names(inpVals))
    
    geomMapArgs <- trimList(
      y=if (need$..density..) '..density..',  # to combine density and histogram plots
      shape=asFactor(ls$shape),
      fill=asFactor(ls$fill),
      size=ls$size,
      color=if (!is.null(ls$treatColorAsFactor) && ls$treatColorAsFactor) 
        asFactor(ls$color) else if (need$densBlackLine) ls$fill else ls$color)
    
    p <- p + do.call(ggpType, trimList(
      mapping=do.call(aes_string, geomMapArgs),
      alpha=ls$alpha, 
      bins=ls$nBins, 
      position=if (!is.null(ls$jitter)) ls$jitter else 
        if (pType %in% c('box', 'violin')) position_dodge(width=0.4) else ls$position,
      size=if (need$sizeMag) ls$sizeMag,
      stat=if (pType == 'bar') 'identity',
      width=if (pType == 'box') 0.2,
      linetype=if (need$sepLines || pType == 'freqpoly') 'dashed'))
    
    guides_args <- na_omit(sapply(names(geomMapArgs), function(aes) {
      if (need$densBlackLine && aes == 'color') {
        guide_legend(title=ls$fill)
      } else if (grepl('^as.factor', geomMapArgs[[aes]])) {
        guide_legend(title=ls[[aes]])
      }
    }, simplify=F))
    
    p <- p + if (length(guides_args)) do.call(guides, guides_args)
    p <- p + if (need$sizeMag) scale_size(range=c(1, ls$sizeMag))
    p <- p + if (!is.null(ls$smooth)) {
      # we need to avoid two different color aestetics: one in geom_, one in smooth 
      # That's why 'else if(is.null(ls$color))' is used
      smoothMapGrp <- 
        if (!is.null(ls$color) && ls$color %in% 
            getVarNamesUniqValsCntLOEN(dataset, attr(inpVals, 'extra')$nCatUniqVals))
        geomMapArgs$color else if (is.null(ls$color)) geomMapArgs$shape
      do.call(stat_smooth,   # stat_smooth(method=.., mapping=..orNull)
              trimList(method=ls$smooth,
                       mapping=if (!is.null(smoothMapGrp))aes_string(color=smoothMapGrp)))
    }
  }
  p
}

plotPairs <- function(dataset, inpVals) {
  stopifnot(length(inpVals) == 1)
  ls <- inpVals[[1]]  
  
  ggpairs_pars <- Filter(
    function(x) !is.null(x), 
    list(dataset, columns=ls$columns,
         # alpha doesnt distinguish 0.2 from 0.8. It's boolean. Looks like a ggpairs bug
         mapping=aes_string(color=ls$color, fill=ls$fill, alpha=0.5),
         upper=list(continuous=ls$pairsUpCont, combo=ls$pairsUpCombo, 
                    discrete=ls$pairsUpDiscr), 
         diag=list(continuous=ls$pairsDiagCont, discrete=ls$pairsDiagDiscr), 
         lower=list(continuous=ls$pairsLowCont, combo=ls$pairsLowCombo, 
                    discrete=ls$pairsLowDiscr)))
  
  reactValPairsAes <- list()
  for(i in 1:length(ggpairs_pars)) {
    par <- ggpairs_pars[[i]]
    par_name <- names(ggpairs_pars)[[i]]
    if (par_name %in% c('upper', 'diag', 'lower') && length(unlist(par))) {
      reactValPairsAes[[par_name]] <- par[!sapply(par, is.null)]
    }
  }
  
  # print.ggmatrix() is overrided in helper.R
  p <- do.call(ggpairs, ggpairs_pars)
  p$pairsAes <- reactValPairsAes
  p
}

getPlotInputVals <- function(structInpNames, df) {
  inputs <- lapply(structInpNames, function(onePlotTypeNames) {
    inp <- lapply(onePlotTypeNames, do.call, args=list(), envir=environment())
    names(inp) <- onePlotTypeNames
    ensureCorrectPlotInputs(inp, colnames(df))
  })
  names(inputs) <- names(structInpNames)
  inputs
}

buildPlot <- reactive({

  # this block waits for controls and prevents premature plot drawing
  if (isolate(reactVals$readyToDraw)) {
    isolate(reactVals$readyToDraw <- F)
  } else {
    isolate({reactVals$itersToDraw <- 5})
    reactVals$readyToDraw  # the only dep if exits here
    return()
  }
  
  pTypes <- plotTypes()
  if (is.null(pTypes)) return()
  df <- aggLimDf()
  isPairsPlot <- all('pairs' == pTypes)
  input_plot_pars <- getPlotInputVals(separatePlotInputs(), df)
  attr(input_plot_pars, 'extra') <- list(nCatUniqVals=isolate(nCatUniqVals()))
  
  if (isPairsPlot) {
    if (length(input_plot_pars[[1]]$columns) == 0) return()
  } else {
    stopifnot(length(input_plot_pars[[1]]$x) > 0)
  }
  
  p <- do.call.pasted('plot', if (isPairsPlot) 'Pairs' else 'Ggplot', 
                      args=list(df, input_plot_pars))
  stopifnot(isPairsPlot || length(p$mapping) > 0)
  if (!is.null(p$pairsAes)) {
    isolate(reactVals$plotState$pairs <- p$pairsAes)
  }
  
  if (!isPairsPlot) {
    if (isFacetSelected()) {
      if (facetGridSelected()) {
        p <- p + facet_grid(facets=facetGrids(), scales=facetScale())
      } else if (facetWrapSelected()) {
        p <- p + facet_wrap(facets=facetWrap(), scales=facetScale())
      }
    }
    
    p <- p + if (coordFlip()) coord_flip()
    
    # plot labels 
    p <- p + if (!is.null(plotTitle()) && plotTitle() != '') ggtitle(plotTitle())
    p <- p + if (!is.null(xLabel()) && xLabel() != '') xlab(xLabel())
    p <- p + if (!is.null(yLabel()) && yLabel() != '') ylab(yLabel())
    
    # plot themes
    if (!is.null(plotTheme())) {
      p <- p + do.call(plotTheme(), list())
      
      theme_name <- rev(unlist(str_split(plotTheme(), '_')))[1]
      
      isolate(reactVals$plotState$theme_name <- theme_name)
      isColorTypeDiscr <- colorType() == 'discrete' #colorType() bases on color()
      if (!theme_name %in% c('grey', 'bw', 'economist')) {
        scale_color_name <- sprintf('scale_colour_%s', theme_name)
        if (theme_name == 'calc') {
          scale_color_name <- sub('u', '', scale_color_name)
        }
        p <- p + if (isColorTypeDiscr && theme_name != 'tufte')
          do.call(scale_color_name, list())
      } else if (theme_name == 'economist') {
        p <- p + scale_colour_economist() + if (isColorTypeDiscr) scale_color_calc()
      }
    }
    
    # plot label styles
    theme_attrs <- list(family = labelFontFamily(),
                        face = labelFontFace(),
                        color = labelFontColor(),
                        size = labelFontSize(),
                        hjust = hjust(),
                        vjust = vjust())
    isolate(reactVals$plotState$theme_attrs <- theme_attrs)
    p <- p + theme(text=do.call(element_text, theme_attrs))
  }
  
  # add plot history entry. It will be shown at Log tab
  isolate({
    if (!is.null(p)) {
      logEntry <- generateCode(p, df, datasetName(), reactVals$plotState)
      curLog <- reactVals$log
      isFirstEntry <- is.null(curLog)
      
      if (isFirstEntry || curLog[[1]] != logEntry) {
        reactVals$log <- if (isFirstEntry) logEntry else c(logEntry, curLog)
      }
    }
  })
  
  p
})

# display plot or table
observeEvent(input$reactive, {
  updateButton(session, "submit", disabled = input$reactive)
  
  if (input$reactive) {
    output$plot <- renderPlot({  # display plot reactively
      buildPlot()
    }, height=700)
    output$displayTable <- DT::renderDataTable({  # display data table reactively
      DT::datatable(manAggDataset(), filter='top', 
                    # remove options to get back the global table search textInput
                    options = list(sDom  = '<"top">lrt<"bottom">ip'))
    })
  } else {
    output$plot <- renderPlot({  # display plot upon submit
      input$submit  # dependency
      isolate(buildPlot())
    }, height=700)
    output$displayTable <- DT::renderDataTable({  # display data table upon submit
      input$submit
      isolate(DT::datatable(manAggDataset(), filter='top',
                            options = list(sDom  = '<"top">lrt<"bottom">ip')))
    })
  }
})

# delay plot building until all controls will be ready
observe({
  nInp <- input$itersToDrawInp
  isolate({
    n <- reactVals$itersToDraw
    if (notNulls(nInp, n) && n != 0) reactVals$itersToDraw <- n - 1
  })
})

# trigger update for plopType options
observe({
  pTypes <- plotTypes()
  isolate({
    if (is.null(dataset())) return()
    allDefTypes <- unlist(getStructListNames(curDatasetPlotInputs()))
    needOneGroupOpts <- length(pTypes) == 1 && 
      length(plotTypesOpts()) == length(allDefTypes)
    
    if (is.null(pTypes) || needOneGroupOpts) {
      reactVals$plotTypeOptsTrigger <- Sys.time()  # Sys.time() for trigger
    }
  })
})

# reset inputs
observeEvent(input$reset_input, {
  updateCheckboxInput(session, "reactive", value = FALSE)
  Sys.sleep(0.5)
  # setdiff prevents very unstable bug of infinite recursive refresh of plotTypes
  for (id in setdiff(names(input), 'datasetName')) {
    reset(id)
  }
  Sys.sleep(0.5)
  updateCheckboxInput(session, "reactive", value = TRUE)
})

# disable/enable toggle between facet grid and facet wrap
observeEvent(buildPlot(), {
  if (!isFacetSelected()) {
    enable('facetRow')
    enable('facetCol')
    enable('facetWrap')
  } else if (facetGridSelected()) {
    enable('facetRow')
    enable('facetCol')
    disable('facetWrap')
  } else if (facetWrapSelected()) {
    disable('facetRow')
    disable('facetCol')
    enable('facetWrap')
  }
})

# collapse all extraPlotBlocks after init
observeEvent(buildPlot(), ({
  if (length(reactVals$log) == 1) {
    updateCollapse(session, "extraPlotBlocks", close = input$extraPlotBlocks)
  }
}))

# to prevent aggregated and limited dataframes collision
observeEvent(input$displayTable_search_columns, {
  if (tolower(plotAggMeth()) != 'none') reset('plotAggMeth')
})

div(
  br(),
  fluidRow(
    column(8, textInput('console', NULL, placeholder = 'Enter R command here')),
    column(3, uiOutput('evalConsoleBtn'))),
  
  pre(textOutput('consoleCtrl'), style="padding-left: 10px; padding-right: 40px;")
)

pacman::p_load(shinyBS, shinyjs, DT)

shinyUI(bootstrapPage(
  headerPanel(windowTitle="ggraptR", title=div()),
  tags$head(tags$style(
    type="text/css",
    "hr {margin-top: 15px; margin-bottom: 15px; border-color: #d9d9d9}",
    ".sbs-panel-group {margin-bottom: 5px;}",
    # ".shiny-split-layout #datasetNameCtrl { overflow: visible; }",
    "#rappy img {max-width: 100%;}"  # "#react_row {max-width: 100%;}"
  )),
  
  sidebarPanel(
    splitLayout(
      cellWidths = c("25%", "75%"),
      imageOutput("rappy", height = "100%"),
      div(
        # use shinyjs to disable/enable buttons w/ JS
        useShinyjs(),
        
        div(
          uiOutput(
            'datasetNameCtrl', style = paste(
              'float: left; margin-right: 83px; width:-webkit-fill-available;
              white-space: nowrap;')),
          div(
            uiOutput('uploadDataCtrl', inline = T),
            uiOutput('datasetOptionsCtrl', inline = T),
            style='float: left; margin-left: -79px; padding-top: 25px')),
        
        conditionalPanel(
          condition = 'input.conditionedPanels == "tableTab"',
          uiOutput('dlBtnCSV')),
        
        conditionalPanel(
          condition = 'input.conditionedPanels != "codeTab"',
          hr(),
          fluidRow(
            column(6, uiOutput('submitCtrl', style='overflow:hidden')), 
            column(6, uiOutput('reactiveCtrl')),
            id='react_row'), 
          actionButton("reset_input", "Reset inputs", icon=icon("refresh"), width = "100%")),
        
        conditionalPanel(
          condition = 'input.conditionedPanels == "codeTab"',
          div(br(), style='padding-bottom: 120px')),
        
        style='padding-left: 10px; padding-right: 4px; overflow: -webkit-paged-x; white-space: normal')),
    hr(),
    
    #### left controls ####
    conditionalPanel(
      condition = 'input.conditionedPanels == "plotTab"',
      source('./views/plotCtrlsUI.R', local=TRUE)$value),
    
    conditionalPanel(
      condition = 'input.conditionedPanels == "tableTab"',
      source('./views/tableCtrlsUI.R', local=TRUE)$value),
    
    conditionalPanel(
      condition = 'input.conditionedPanels == "codeTab"',
      source('./views/codeCtrlsUI.R', local=TRUE)$value)),
  
  #### right view ####
  mainPanel(
    source('./views/modalPanels.R',local=TRUE)$value,
    
    tabsetPanel(
      type = "tabs",
      tabPanel(
        "Plot", br(), br(),
        plotOutput("plot", brush=brushOpts(id="zoom_brush",resetOnNew=T)),
        uiOutput("itersToDrawCtrl", 
                 style="opacity: 0; pointer-events: none"),
        value='plotTab'), 
      
      tabPanel(
        "Table", br(), br(),
        DT::dataTableOutput("displayTable"),
        value='tableTab'),
      
      tabPanel(
        'Code', br(),
        strong('Plot log (latest at the top):'),
        br(), br(),
        htmlOutput('plotLog'),
        value='codeTab'),
      id = "conditionedPanels"))))

# debugger configuration

# prepare txtCfg to read configuration file
txtCfg <- tryCatch(
  read.delim("debug/debug.cfg.json", 
             comment.char="#", quote="", header=F)$V1 %>% as.character,
  error = function(e) { "" })

# if txtCfg populated then logging is on, read extracted json record
if (nchar(txtCfg) > 0) {
  # read json configuration string
  jsonCfg <- fromJSON(txtCfg)
  
  if (jsonCfg$logs == "all") {
    flog.appender(appender.file('./debug/debug.log'), name='all')
    flog.threshold(DEBUG, name='all')  
  }
  
  if (jsonCfg$format == "simple") {
    flog.layout(layout.simple, name='all')
  }
  
  if (jsonCfg$format == "json") {
    flog.layout(layout.json, name='all')
  }
} else {
  # logging is off, only logs of level FATAL will be written. no such logs exist in the code,
  # so none will be written
  flog.threshold(FATAL)  
}

suppressWarnings(rm(txtCfg))
flog.debug("Debug logging initiated", name='all')

div(
  
  bsModal("modalUploadOptions", "Upload dataset", "uploadDataCtrl",
          source('./views/addDatasetCtrlsUI.R', local=TRUE)$value),
  
  bsModal("modalDownloadPlotOptions", "Plot download options", "dlPlotOpenModalCtrl", 
          size = "small",
          uiOutput('fileHeightCtrl'), uiOutput('fileWidthCtrl'),
          uiOutput('fileDPICtrl'), uiOutput('fileTypeCtrl'), uiOutput('dlPlotCtrl')),
  
  bsModal("datasetOptions", "Dataset options", "datasetOptionsCtrl", size = "small", 
          numericInput(
            "nCatUniqVals", value=6, min=0,
            label = "Count of unique values to treat numeric feature as categorical,
            less or equal")),
  
  bsModal("pTypesWarnModal", "Plot type warning", "pTypesWarnBtnCtrl", size = "small", 
          textOutput('pTypesWarnModalMessageCtrl'))

)

# if we abandon keep the default first value of selectInput list
# then we will lost any input state after collapsing aestetic elements block

output$itersToDrawCtrl <- renderUI({
  n <- reactVals$itersToDraw
  if (is.null(n)) return()
  if (n > 0) {
    numericInput('itersToDrawInp', NULL, n, width = '80px')  # 1px
  } else {
    reactVals$readyToDraw <- T
    NULL
  }
})

output$plotTypesCtrl <- renderUI({
  if (is.null(dataset())) return()  # trigger
  curGroupAllOpts <- plotTypesOpts()
  
  isolate({
    pTypes <- plotTypes()
    isInit <- all(sapply(c(x(), y(), columns(), plotTypes()), is.null))
    
    if (isInit) {
      inp <- getInitialArg('initialPlot')
      initialPlot <- if (is.null(inp)) NULL else
        inp %>% tolower() %>% gsub('(plot)| ', '', .)
    }
    
    ls <- list()
    ls[c('opts', 'val')] <- if (isInit) {
      opts <- getPlotTypeOpts(initialPlot, 
                              length(numericVars()), length(categoricalVars()))
      list(opts, if (!is.null(initialPlot)) initialPlot else if (!is.null(opts)) opts[1])
    } else if (reactVals$is_dataset_changed > 0) {
      if (is.null(pTypes)) list(list('Histogram' = 'histogram'), 'histogram')
    } else {
      reactVals$is_dataset_changed <- 0.5  # will be flipped in plotTypesOpts()
      list(curGroupAllOpts, pTypes)
    }
    
    selectInput("plotTypes", "Plot type", ls$opts, ls$val, multiple = T)
  })
})


#### main ####
output$xCtrl <- renderUI({
  if (displayXCond()) {
    isolate({
      varType <- if (needCatX(plotTypes())) 'categorical' else 'numeric'
      vars <- do.call.pasted(varType, 'Vars')
      if (!length(vars)) varType <- sprintf('%s. Absent' , varType)
      selectInput('x', sprintf('X (%s)', varType), vars, selected = x())
    })
  }
})

output$yCtrl <- renderUI({
  if (displayYCond()) {
    isolate({
      isDiamondsInit <- datasetName() == 'diamonds' && is.null(y())
      vars <- setdiff(numericVars(), if (displayXCond()) x())
      selectInput('y', paste0('Y (numeric', if (!length(vars)) '. Absent', ')'), vars,
                  if (isDiamondsInit) 'price' else y())
    })
  }
})

# columns for pairsPlot
output$columnsCtrl <- renderUI({
  if (displayGgpairsColumnsCond()) {
    isolate(selectInput(
      'columns', 'Columns', choices=names(dataset()),
      selected=if (is.null(columns())) names(dataset())[1:min(ncol(dataset()), 3)] else
        columns(), multiple=T))
  }
})

output$colorCtrl <- renderUI({
  if (displayColorCond()) {
    isolate({
      isScatter <- all('scatter' == plotTypes())
      isDiamondsInit <- isScatter && datasetName() == 'diamonds' && is.null(y())
      opts <- c('None', if (isScatter) 
                 names(dataset()) else categoricalVars())
      
      selectInput('color', 'Color', opts, if (isDiamondsInit) 'color' else color())
    })
  }
})

output$treatColorAsFactorCtrl <- renderUI({
  if (displayTreatAsFactorCond()) {
    isolate(checkboxInput('treatColorAsFactor', 'Treat color as a factor', value=F))
  }
})

output$fillCtrl <- renderUI({
  if (displayFillCond()) {
    isolate(selectInput('fill', 'Fill', c('None', categoricalVars()), fillOrig()))
  }
})

output$sizeCtrl <- renderUI({
  if (displaySizeCond()) {
    isolate(selectInput('size', 'Size', c('None', numericVars()), sizeOrig()))
  }
})

output$shapeCtrl <- renderUI({
  if (displayShapeCond()) {
    isolate(selectInput('shape', 'Shape', c('None', categoricalVars()), shapeOrig()))
  }
})

# position (stack vs. dodge) control options
output$positionCtrl <- renderUI({
  if (displayPositionCond()) {
    isolate(selectInput('position', 'Position', c('stack', 'dodge', 'fill'), position()))
  }
})

output$jitterCtrl <- renderUI({
  if (displayJitterCond()) {
    is_agg_empty <- is.null(plotAggMeth()) || tolower(plotAggMeth()) == 'none'
    isolate(checkboxInput('jitter', 'Apply jitter effect', 
                          all('scatter' == plotTypes()) && is_agg_empty))
  }
})

output$coordFlipCtrl <- renderUI({
  if (displayCoordFlipCond()) {
    isolate(checkboxInput('coordFlip', 'Flip X and Y axis', value=F))
  }
})

output$smoothCtrl <- renderUI({
  if (displaySmthCond()) {
    isolate(selectInput('smooth', 'Smoothing Effect',
                        c('None'='None', 'Linear'='lm', 'Non-linear'='auto'), 
                        smoothOrig()))
  } 
})

output$alphaCtrl <- renderUI({
  if (displayAlphaCond()) {
    sliderInput("alpha", label = "Opacity",
                min=0, max=1, value=0.5, step=0.1)
  }
})

# size magnifier
output$sizeMagCtrl <- renderUI({
  if (displaySizeMagCond()) {
    sliderInput("sizeMag", label="Size Magnifier",
                min=1, max=25, value=3, step=1)
  }
})

output$nBinsCtrl <- renderUI({  # histogram bins options
  if (displayBinsCond()) {
    isolate(sliderInput('nBins', label = "Number of bins", min=5, max=100, 
                        value=if (is.null(nBins())) 16 else nBins()))
  }
})

# density plot color options
output$densBlackLineCtrl <- renderUI({
  if (displayDensBlackLineCond()) {
    isolate(checkboxInput('densBlackLine', 'Draw black outline', 
                          value=densBlackLine()))
  }
})


#### pairs ####
output$pairsUpContCtrl <- renderUI({
  if (displayGgpairsCond()) {
    isolate(selectInput(
      'pairsUpCont', NULL, 
      c('points', 'smooth', 'smooth_loess', 'density', 'cor', 'blank'),
      getFirstNonNull(pairsUpCont(), eval(formals(ggpairs)$upper)$continuous)))
  }
})

output$pairsUpComboCtrl <- renderUI({
  if (displayGgpairsCond()) {
    isolate(selectInput(
      'pairsUpCombo', NULL,
      c('box', 'dot', 'facethist', 'facetdensity', 'denstrip','blank'),
      getFirstNonNull(pairsUpCombo(), eval(formals(ggpairs)$upper)$combo)))
  }
})

output$pairsUpDiscrCtrl <- renderUI({
  if (displayGgpairsCond()) {
    isolate(selectInput(
      'pairsUpDiscr', NULL,
      c('facetba'='facetbar', 'ratio', 'blank'),
      getFirstNonNull(pairsUpDiscr(), eval(formals(ggpairs)$upper)$discrete)))
  }
})

output$pairsLowContCtrl <- renderUI({
  if (displayGgpairsCond()) {
    isolate(selectInput(
      'pairsLowCont', NULL, 
      c('points', 'smooth', 'smooth_loess', 'density', 'cor', 'blank'),
      getFirstNonNull(pairsLowCont(), eval(formals(ggpairs)$lower)$continuous)))
  }
})

output$pairsLowComboCtrl <- renderUI({
  if (displayGgpairsCond()) {
    isolate(selectInput(
      'pairsLowCombo', NULL, 
      c('box', 'dot', 'facethi'='facethist', 'facetdensity', 'denstrip', 'blank'),
      getFirstNonNull(pairsLowCombo(), eval(formals(ggpairs)$lower)$combo)))
  }
})

output$pairsLowDiscrCtrl <- renderUI({
  if (displayGgpairsCond()) {
    isolate(selectInput(
      'pairsLowDiscr', NULL, 
      c('facetba'='facetbar', 'ratio', 'blank'),
      getFirstNonNull(pairsLowDiscr(), eval(formals(ggpairs)$lower)$discrete)))
  }
})

output$pairsDiagContCtrl <- renderUI({
  if (displayGgpairsCond()) {
    isolate(selectInput(
      'pairsDiagCont', NULL,
      c('density'='densityDiag', 'bar'='barDiag', 'blank'='blankDiag'),
      getFirstNonNull(pairsDiagCont(), eval(formals(ggpairs)$diag)$continuous)))
  }
})

output$pairsDiagDiscrCtrl <- renderUI({
  if (displayGgpairsCond()) {
    isolate(selectInput(
      'pairsDiagDiscr', NULL,
      c('bar'='barDiag', 'blank'='blankDiag'),
      getFirstNonNull(pairsDiagDiscr(), eval(formals(ggpairs)$diag)$discrete)))
  }
})


#### facets ####
output$facetRowCtrl <- renderUI({
  if (displayFacetCond()) {
    isolate(selectInput('facetRow', 'Facet Row', 
                        c('None', categoricalVars()), facetRowOrig()))
  }
})

output$facetColCtrl <- renderUI({
  facetRow <- facetRowOrig()
  if (displayFacetCond()) {
    isolate(selectInput('facetCol', 'Facet Column',
                        c('None', setdiff(categoricalVars(), facetRow)),
                        facetColOrig()))
  }
})

output$facetWrapCtrl <- renderUI({
  if (displayFacetCond()) {
    isolate(selectInput('facetWrap', 'Facet Wrap', 
                        c('None', categoricalVars()), facetWrapOrig()))
  }
})

output$facetScaleCtrl <- renderUI({
  if (displayFacetCond()) {
    isolate(selectInput('facetScale', 'Facet Scale',
                        c('None'='fixed', 'Free X'='free_x', 'Free Y'='free_y', 
                          'Free X & Y'='free'),
                        facetScale()))
  }
})


#### theme ####
output$plotTitleCtrl <- renderUI({
  isolate(textInput('plotTitle', 'Plot Title', value=plotTitle()))
})

output$xLabelCtrl <- renderUI({
  isolate(textInput('xLabel', 'X Label', value=xLabel()))
})

output$yLabelCtrl <- renderUI({
  isolate(textInput('yLabel', 'Y Label', value=yLabel()))
})

output$labelFontFamilyCtrl <- renderUI({
  # only the first 3 fonts are available on Windows machine. Next ones generate warnings
  labelFontFamilyOpts <- c('sans', 'serif', 'mono', 'Calibri', 
                           'Times', 'Helvetica', 'Courier')
  isolate(selectInput('labelFontFamily', 'Label Font Family', labelFontFamilyOpts, 
                      labelFontFamily()))
})

output$labelFontFaceCtrl <- renderUI({
  labelFontFaceOpts <- c('plain', 'bold', 'italic', 'bold.italic')
  isolate(selectInput('labelFontFace', 'Label Font Face', 
                      labelFontFaceOpts, labelFontFace()))
})

output$labelFontSizeCtrl <- renderUI({
  isolate(numericInput('labelFontSize', 'Label Font Size', value=labelFontSize(), 
                       min=7, max=30, step=1))
})

output$labelFontColorCtrl <- renderUI({
  isolate(colourInput('labelFontColor', 'Label Font Color',
                      value=labelFontColor()))
})

output$hjustCtrl <- renderUI({
  isolate(numericInput('hjust', 'Horizontal Adjust', hjust(), min=0, max=1, step=0.1))
})

output$vjustCtrl <- renderUI({
  isolate(numericInput('vjust', 'Vertical Adjust', vjust(), min=0, max=1, step=0.1))
})

output$plotThemeCtrl <- renderUI({
  themes <- c('Grey' = 'theme_grey', 
              'Black and White' = 'theme_bw', 
              'LibreOffice Calc' = 'theme_calc',
              'The Economist' = 'theme_economist',
              'Stephen Few' = 'theme_few',
              '538' = 'theme_fivethirtyeight', 
              'Google Docs' = 'theme_gdocs', 
              'HighCharts' = 'theme_hc', 
              'pander' = 'theme_pander', 
              'solarized' = 'theme_solarized', 
              'Stata' = 'theme_stata', 
              'Tufte' = 'theme_tufte', 
              'Wall Street Journal' = 'theme_wsj')
  isolate(selectInput('plotTheme', 'Plot Theme', themes, plotTheme()))
})


#### aggregations ####
# raw vs. manually aggregated. Plot tab
output$rawVsManAggCtrl <- renderUI({
  isolate(selectInput("rawVsManAgg", "Dataset Type",
                      c("Raw Dataset" = 'raw', "Manually Aggregated" = 'manAgg'),
                      rawVsManAgg()))
})

# aggregation method (sum, mean, ...). Plot tab
output$plotAggMethCtrl <- renderUI({
  plotTypes()
  isolate(selectInput('plotAggMeth', 'Aggregation Method', 
                      c('None', 'sum', 'mean', 'count', 'min', 'max', 'median'),
                      plotAggMeth()))
})

# additional aggregation by feature options. Plot tab
output$plotAddAggByCtrl <- renderUI({
  if (!is.null(plotTypes()) && semiAutoAggOn()) {
    isolate(selectInput('plotAddAggBy', 'Additional Aggregation Variables', 
                        choices=setdiff(colnames(rawDataset()), plotSemiAutoAggByBase()), 
                        multiple=T, selected=plotAddAggBy()))
  }
})

snakeize <- function(camel_str) {
  s <- gsub("([a-z])([A-Z])", "\\1_\\L\\2", camel_str, perl = TRUE)
  sub("^(.[a-z])", "\\L\\1", s, perl = TRUE) # make 1st char lower case
}

parse_kv <- function(str, sep='_') {
  do.call(sprintf, as.list(unlist(c('%s="%s"', str_split(str, sep)))))
}

wrap_quote <- function(el, need_quote) {
  if (is.character(el) && need_quote) {
    sprintf('"%s"', el)
  } else if (is.language(el)) {
    res <- as.character(list(el))
    if ("quosure" %in% class(el)) sub("^~", "", res) else res
  } else as.character(el)
}

clist <- function(arg_lst, need_quote=T) {
  arg_lst <- arg_lst[!sapply(arg_lst, is.null)]
  paste(
    sapply(1:length(arg_lst), function(par_i) 
    sprintf('%s=%s', names(arg_lst)[par_i], wrap_quote(arg_lst[[par_i]], need_quote))),
    collapse=', ')
}

generateCode <- function(p, df, df_name, state) {
  df_name_filtered <- if (!is.null(state$filter)) 
    applied_filters_expr(df, df_name, state$filter$keys, state$filter$vals) else df_name
  
  if ('ggmatrix' %in% class(p)) {
    cols <- paste(sapply(p$xAxisLabels, function(w) sprintf('"%s"', w)), collapse=', ')
    mapping <- p$plots[[1]]$mapping
    print_mapping <- mapping[setdiff(names(mapping), c('x', 'y'))]
    map_aes <- if (length(print_mapping)) 
      sprintf(' mapping=aes(%s),', clist(print_mapping)) else ''
    adjustment <- if (is.null(state$pairs)) '' else paste0(', ',
      clist(lapply(state$pairs, function(x) sprintf('list(%s)', clist(x))), F))
    
    return(sprintf('ggpairs(%s,%s columns=c(%s)%s)',
                   df_name_filtered, map_aes, cols, adjustment))
  }
  
  p$mapping <- rev(p$mapping)
  res <- sprintf('ggplot(%s, aes(%s))', df_name_filtered, clist(p$mapping))
  
  for (layer in p$layers) {
    if (any(class(layer$geom) == 'Geom')) {
      geom_name <- snakeize(class(layer$geom)[[1]])
      geom_params <- paste(parse_kv(snakeize(class(layer$stat)[[1]])), 
                           parse_kv(snakeize(class(layer$position)[[1]])), sep=', ')
      if (!is.null(layer$aes_params) && length(layer$aes_params)) {
        geom_params <- paste(geom_params, clist(layer$aes_params), sep=', ')
      }
      if (!is.null(layer$mapping) && length(layer$mapping)) {
        aes_mapping_mask <- sapply(layer$mapping, function(x) !is.null(x))
        if (any(aes_mapping_mask)) {
          geom_params <- sprintf('aes(%s), %s', clist(layer$mapping[aes_mapping_mask]), 
                                 geom_params)
        }
      }
      # for (params in c(layer$stat_params, layer$geom_params)) {
      # collision na.rm=F for both stat_params and geom_params
      param_mask <- sapply(layer$stat_params, function(x)
        !is.null(x) && !is.na(x) &&
          (!is.logical(x) || x) && 
          (!is.numeric(x) || x > 0) &&
          ((!is.vector(x) && !is.list(x)) || length(x) > 0))
      if (any(param_mask)) {
        useful_params <- layer$stat_params[param_mask]
        geom_params <- paste(geom_params, clist(useful_params), sep=', ')
        if ('bins' %in% names(useful_params) && geom_name == 'geom_bar') {
          geom_name <- 'geom_histogram'
        }
      }
      res <- sprintf('%s + %s(%s)', res, geom_name, geom_params)
    }
  }
  
  if (all(class(p$facet) != 'FacetNull')) {
    isWrap <- !is.null(p$facet$params$facets)
    facetFormula <- sapply(if (isWrap)'facets' else  c('rows', 'cols'), function(ax) {
      dividers <- p$facet$params[[ax]]
      if (!length(dividers)) '.' else paste(names(dividers), collapse = '+')
    })
    res <- sprintf('%s + facet_%s(%s%s)', res, 
                   if (isWrap) 'wrap' else 'grid', 
                   if (isWrap) '~ ' else '',
                   paste(facetFormula, collapse = ' ~ '))
    
    free_mask <- unlist(p$facet$params$free)
    if (any(free_mask)) {
      res <- sub(')$', sprintf(
        ', scales="free%s")', 
        if (all(free_mask)) '' else if (free_mask['x']) '_x' else '_y'), res)
    }
  }
  
  if (class(p$coordinates)[1] == 'CoordFlip') {
    res <- sprintf('%s + %s()', res, snakeize(class(p$coordinates)[1]))
  }
  
  if (!is.null(state$theme_name)) {
    res <- sprintf('%s + theme_%s()', res, state$theme_name)
  }
  if (!is.null(state$theme_attrs)) {
    res <- sprintf('%s + theme(text=element_text(%s))', res, clist(state$theme_attrs))
  }
  
  for (scale in p$scales$scales) {
    if (scale$aesthetics == 'size') {
      # I have found that range information stores as an inner function
      # print(scale_size) -> continuous_scale(.., palette=area_pal(range)) -> 
      # ... -> ggproto(palette=palette)
      # so we can restore range's low and high by palette() out solving equation: 
      # sqrt(in)*(high-low)+low=out
      low <- p$scales$scales[[1]]$palette(0)
      high <- p$scales$scales[[1]]$palette(1)
      res <- sprintf('%s + scale_size(range=c(%s, %s))', res, low, high)
    } else if (scale$aesthetics == 'colour') {
      res <- sprintf('%s + scale_color_%s()', res, scale$scale_name)
    }
  }
  
  if ('guides' %in% names(p)) {
    guide_params <- c()
    for (guide_i in 1:length(p$guides)) {
      guide_name <- names(p$guides)[guide_i]
      guide <- p$guides[[guide_i]]
      if (!is.null(guide$title) && guide_name != guide$title) {
        guide_params <- c(guide_params, sprintf('%s=guide_legend(title="%s")', 
                                                guide_name, guide$title))
      }
    }
    if (length(guide_params)) {
      res <- sprintf('%s + guides(%s)', res, paste(guide_params, collapse=', '))
    }
  }
  
  for (lab in c('title', 'x', 'y')) {
    if (!is.null(p$labels[[lab]])) {
      res <- sprintf('%s + %s("%s")', res, 
                     if (lab == 'title') 'ggtitle' else paste0(lab, 'lab'), 
                     p$labels[[lab]])
    }
  }
  
  res
}

verticalLayout(
  
  conditionalPanel(condition = 'input.plotTypes == "pairs"',
    fluidRow(
      column(2, div()), 
      column(3, div(strong('Upper plots'))),
      column(3, div(strong('Lower'))), 
      column(3, div(strong('Diag plots')))),
    br(),
    
    fluidRow(
      column(2, div(strong('Continu'))), 
      column(3, uiOutput('pairsUpContCtrl')),
      column(3, uiOutput('pairsLowContCtrl')), 
      column(3, uiOutput('pairsDiagContCtrl'))),
      
    fluidRow(
      column(2, div(strong('Discrete'))), 
      column(3, uiOutput('pairsUpDiscrCtrl')),
      column(3, uiOutput('pairsLowDiscrCtrl')), 
      column(3, uiOutput('pairsDiagDiscrCtrl'))),
    
    fluidRow(
      column(2, div(strong('Combo'))), 
      column(3, uiOutput('pairsUpComboCtrl')),
      column(3, uiOutput('pairsLowComboCtrl'))),
    hr()),
    
  
  fluidRow(
    column(6, uiOutput('colorCtrl')),
    column(6, br(), uiOutput('treatColorAsFactorCtrl'))),
  
  fluidRow(
    column(6, uiOutput('fillCtrl')),
    column(6, uiOutput('positionCtrl'))),
  
  fluidRow(
    column(6, uiOutput('sizeCtrl')),
    column(6, uiOutput('shapeCtrl'))),
  
  fluidRow(
    column(6, uiOutput('smoothCtrl'))),
  
  fluidRow(
    column(6, uiOutput('coordFlipCtrl')),
    column(6, uiOutput('jitterCtrl'))),
  
  uiOutput('alphaCtrl'),
  uiOutput('sizeMagCtrl'),
  uiOutput('nBinsCtrl'),
  
  uiOutput('densBlackLineCtrl')
)

# note: the functions below will find year (YYYY), month (YYYY-MM), 
# and date (YYYY-MM-DD) between 1800-01-01 and 2099-12-31
# this functions determines the name of the year column (in YYYY format)
getYearColumnName <- function(df) {
  firstRow <- df[1, ]
  yearPtrn <- '^(18|19|20)[0-9]{2}$'
  potentialYearCol <- colnames(df)[grepl(yearPtrn, firstRow)]
  yearCol <- c()
  for (col in potentialYearCol) {
    if (all(grepl(yearPtrn, df[[col]]))) {
      yearCol <- c(yearCol, col)
    }
  }
  yearCol
}

# determines the name of the month column (in YYYY-MM format)
getMonthColumnName <- function(df) {
  firstRow <- df[1, ]
  yearMonthPtrn <- '^(18|19|20)[0-9]{2}[- /.](0[1-9]|1[012])$'
  potentialYearMonthCol <- colnames(df)[grepl(yearMonthPtrn, firstRow)]
  yearMonthCol <- c()
  for (col in potentialYearMonthCol) {
    if (all(grepl(yearMonthPtrn, df[[col]]))) {
      yearMonthCol <- c(yearMonthCol, col)
    }
  }
  yearMonthCol
}

# determines the name of the day column (in YYYY-MM-DD format)
getDateColumnName <- function(df) {
  firstRow <- as.character(df[1, ])
  datePtrn <- '^(18|19|20)[0-9]{2}[- /.](0[1-9]|1[012])[- /.](0[1-9]|[12][0-9]|3[01])$'
  potentialDateCol <- colnames(df)[grepl(datePtrn, firstRow)]
  dateCol <- c()  
  for (col in potentialDateCol) {
    if (all(grepl(datePtrn, as.character(df[[col]])))) {
      dateCol <- c(dateCol, col)
    }
  }
  dateCol
}

# gets all variable names of data frame objects that are loaded into memory
getPreloadedEnvDfNames <- function(env=.GlobalEnv) {
  objNames <- ls(env)
  dfNames <- c()
  for (objName in objNames) {
    obj <- get(objName)
    if (any(class(obj)=='data.frame')) {
      dfNames <- c(dfNames, objName)
    }
  }
  dfNames
}

# function for cleaning (removing duplicates or "None" values, etc.)
cleanPlotAggBy <- function(x, y, aggBy) {
  aggBy <- c(x, aggBy)
  aggBy <- unique(aggBy)
  nonAggBy <- c('None', 'none', '.')
  
  # remove nonAggBy from aggBy
  aggBy <- setdiff(aggBy, nonAggBy)
  
  if (x != y)
    aggBy <- setdiff(aggBy, y)
  
  aggBy
}

# ensures correct plot inputs for an updated dataset
ensureCorrectPlotInputs <- function(plotInputsList, colnames) {
  for (name in names(plotInputsList)) {
    if (!is.null(plotInputsList[[name]])) {
      if (name %in% c('x', 'y', 'facetRow', 'facetCol', 'facetWrap') &&
          !(plotInputsList[[name]] %in% colnames)) { 
        # problem here can be produced by staled aggLimDf() %>% names
        # warning('Incorrect plot input has been nulled: ', name)
        plotInputsList[name] <- list(NULL)
      } else if (name %in% c('color', 'size', 'shape') &&
                 !(plotInputsList[[name]] %in% colnames)) {
        asFactorName <- paste0(name, 'AsFactor')
        plotInputsList[name] <- plotInputsList[asFactorName] <- list(NULL)
      }
    }
  }
  plotInputsList
}

# modifies and ensures proper variable name
# for semi-automatic aggregation dataset column names
ensureProperVarName <- function(colnames, var, aggMeth, semiAutoAggOn) {
  if (anyNull(colnames, var, aggMeth, semiAutoAggOn)) return()
  if (tolower(var) %in% c('none', '.')) return(var)
  
  # only if original variable name is not found in dataset's column names
  if (!(var %in% colnames)) {
    # if semi-automatic aggregation is turned on
    if (semiAutoAggOn) {
      return(if (aggMeth=='count') 'count' else paste0(var, '_', aggMeth))
    }
  } else {  # if original variable name is found in dataset's column names
    varAgg <- paste0(var, '_', aggMeth)
    if (varAgg %in% colnames) {
      return(varAgg)
    }
  }
  var
}


# functions for plotType options
# makes structured list like one in globals.R simple flat list with vectors like elements
flattenList <- function(lst) {
  res <- list()
  for (lsti in 1:length(lst)) {
    el <- lst[lsti]
    if (is.list(el[[1]])) {
      i <- (1:length(el[[1]])) + length(res)
      res[i] <- el[[1]]
      names(res)[i] <- names(el[[1]])
    } else {
      i <- length(res) + 1
      res[i] <- el
      names(res)[i] <- names(el)
    }
  }
  res
}

# preserves list structure and extracts only list elements names
getStructListNames <- function(lst) {
  if (is.null(lst)) return()
  res <- list()
  for (i in 1:length(lst)) {
    el <- lst[i]
    if (is.list(el[[1]])) {
      res[[length(res) + 1]] <- c(names(el[[1]]))
    } else {
      res[[i]] <- names(el)
    }
  }
  res
}

getPlotTypeOpts <- function(selectedOpts, n_num, n_cat) {
  defInputs <- getDefinedPlotInputs(n_num, n_cat)
  if (is.null(defInputs)) return()
  plotTypeRelations <- getStructListNames(defInputs)
  opts <- unlist(plotTypeRelations[
    if (is.null(selectedOpts)) T else {
      sapply(plotTypeRelations, function(el) unlist(selectedOpts)[1] %in% el)
    }])
  names(opts) <- sapply(opts, function(x) capitalize(x) %>% gsub('(\\d)', ' \\1', .))
  opts
}


needCatX <- function(plotTypes) {
  any(c('violin', 'box', 'bar') %in% plotTypes)
}

# override GGally:::print.ggmatrix to prevent messages about binwdth
print.ggmatrix <- function(x, newpage = is.null(vp), vp = NULL, ...) {
  suppressMessages(GGally:::print.ggmatrix(x, newpage, vp, list(...)))
}

sourceAllInDir <- function(folder, local=F, except=NULL) {
  for (fl in dir(folder)) {
    if (!fl %in% except) {
      # 'envir' to set up environment - server() call - which contains 'output' variable
      do.call(source, list(paste(folder, fl, sep = '/'), local), envir = sys.frame(-1))
    }
  }
}


# common functions
getIsFactorVarNames <- function(df) {
  colnames(df)[sapply(df, is.factor)]
}

getIsNumericVarNames <- function(df) {
  colnames(df)[sapply(df, is.numeric)]
}

# grabs the names variables of whose number of unique values does not exceed 
# a specified threshold (LOE: less than or equal to)
getVarNamesUniqValsCntLOEN <- function(df, nCatUniqVals) {
  colnames(df)[sapply(df, function(x) length(unique(x)) <= nCatUniqVals)]
}

convertNoneToNULL <- function(var) {
  if (!is.null(var) && tolower(var) != 'none' && nchar(var)) var  # otherwise NULL
}

asFactor <- function(var) {
  if (!is.null(var)) paste0('as.factor(', var, ')')
}

notNulls <- function(...) {  # effective lazy implementation
  for (el in list(...)) if (is.null(el)) return(FALSE)
  TRUE
}

anyNull <- function(...) {
  !notNulls(...)
}

not_null_true <- function(x) !is.null(x) && x
not_null_false <- function(x) !is.null(x) && !x

na_omit <- function(lst) Filter(function(x) !is.null(x) && length(x), lst)

trimList <- function(...) na_omit(list(...))

applied_filters_expr <- function(df, df_name, filter_keys, filter_vals) {
  stopifnot(notNulls(lst, filter_keys, filter_vals),
            length(lst) > 0, length(filter_keys) > 0,
            length(filter_keys) == length(filter_vals))
  
  filter_mask_txt <- sapply(1:length(filter_keys), function(i) {
    col_name <- filter_keys[i]
    vals <- filter_vals[[i]]
    is_num <- is.numeric(df[[col_name]])
    
    if ((is_num && length(vals) != 2) || length(vals) == 0) {
      stop('df_name: ', df_name, 'col_name: ', col_name,
           'is_num: ', is_num, 'length(vals): ', length(vals))
    }
    
    filter_cond <- paste0(vals, collapse=', ')
    sprintf(if (is_num) 'between(%s, %s)' else '%s %%in%% c(%s)', 
            col_name, filter_cond)
  })
  
  sprintf('%s[with(%s, %s), ]', 
          df_name, df_name, paste(filter_mask_txt, collapse = ' & '))
}

# 'foo' -> 'Foo'
capitalize <- function(x) {
  paste0(toupper(substr(x, 1, 1)), substr(x, 2, nchar(x)))
}

do.call.pasted <- function(..., args=list()) {
  do.call(paste(trimList(...), collapse=''), args, envir=parent.env(parent.frame()))
}

getFirstNonNull <- function(...) {
  for (el in list(...)) if (!is.null(el)) return(el)
  stop()
}

getInitialArg <- function(argName) {
  # a workaround for rsconnect::deployApp('inst/ggraptR')
  ggraptrFormals <- try(names(formals(eval(parse(text="ggraptR::ggraptR")))), silent = T)
  if (class(ggraptrFormals) == 'try-error') return(NULL)
  ggraptrFormals <- setdiff(ggraptrFormals, '...')

  envIds <- which(
    sapply(0:length(sys.frames()), function(ienv) 
      !length(setdiff(ggraptrFormals, ls(envir=sys.frame(ienv)))))) - 1
  
  tryCatch(get(argName, envir=sys.frame(envIds[1])), error=function(e){})
}

tabsetPanel(
  type = "tabs",
  tabPanel(
    "File", 
    verticalLayout(
      br(),
      uiOutput('fileInputSelectCtrl'),
      
      fluidRow(
        column(4, uiOutput('fileInputHeaderCtrl')),
        column(4, uiOutput('fileInputQuoteCtrl')),
        column(4, uiOutput('fileInputSepCtrl')))),

    value='addFileTab'),
  
  tabPanel(
    "Database",
    br(),
    splitLayout(
      cellWidths = c("25%", "75%"),
      uiOutput('dbDriverTypeCtrl'),
     
      div(
        fluidRow(
          column(8, textInput('dbHost', 'Host', 'db4free.net')),
          column(4, textInput('dbPort', 'Port', '3307'))),
       
        fluidRow(
          column(6, textInput('dbUser', 'User', 'gray')),
          column(6, passwordInput('dbPass', 'Password', '12348888'))),
       
          textInput('dbName', 'Db name', 'ggtest'),
        
        style='padding-right: 15px;')),
    
    br(),
    fluidRow(
      column(9, textAreaInput('dbSqlQuery', 'Sql query', 'select * from diam_db_short',
                              width='430px')),
      column(3, uiOutput('dbExecuteBtn'), style='padding-top:25px')),
    
    value='addDbTab'),
  
  id = 'addDatasetTabset',
  selected = 'addDbTab'
)

# plotTypes in inner lists are treated as allowed to plot together in plotTypeOpts()
getDefinedPlotInputs <- function(n_num, n_cat) {
  if (n_num == 0) return()
  trimList(
    if (n_num > 1) {
      list(scatter=c('x', 'y', 'color', 'treatColorAsFactor', 'shape', 'size', 'smooth', 
                   'jitter', 'alpha', 'sizeMag'),
         line=c('x', 'y', 'color', 'alpha'),
         path=c('x', 'y', 'color', 'alpha'),
         density2d=c('x', 'y'),
         bin2d=c('x', 'y', 'alpha', 'fill', 'nBins'), # position
         hex=c('x', 'y', 'alpha','color',  'fill', 'size', 'nBins'))
    },
    if (n_cat > 0) {
      list(box=c('x', 'y', 'fill', 'alpha'),
           violin=c('x', 'y', 'fill', 'alpha'),
         bar=c('x','y', 'fill', 'alpha', 'position'))
    },
    list(histogram=c('x', 'fill', 'alpha', 'position', 'nBins'),
         freqpoly=c('x', 'color', 'nBins'),
         density=c('x', 'fill', 'alpha', 'densBlackLine')),
    pairs=c('columns', 'color', 'fill',
            'pairsUpCont', 'pairsUpCombo', 'pairsUpDiscr',
            'pairsDiagCont', 'pairsDiagDiscr',
            'pairsLowCont', 'pairsLowCombo', 'pairsLowDiscr'))
}

getFileDefault <- function() {
  list(width=10, height=10, DPI=100, widthMax=50, heightMax=50, DPIMax=500)
}

# file input select control
output$fileInputSelectCtrl <- renderUI({
  rawDataset()
  fileInput('file', 'Choose file to upload', 
            accept=c('text/csv', 'text/comma-separated-values', 
                     'text/tab-separated-values', 'text/plain', '.csv', '.tsv'))
})

# file input header control
output$fileInputHeaderCtrl <- renderUI({
  checkboxGroupInput('header', 'Header Options', choices=c('Header'=TRUE), selected=T)  
})

# file input quote control
output$fileInputQuoteCtrl <- renderUI({
  radioButtons('quote', 'Quote', c(None='', 'Double Quote'='"', 'Single Quote'="'"), '"')  
})

# file input separator control
output$fileInputSepCtrl <- renderUI({
  radioButtons('sep', 'Separator', c(Comma=',', Semicolon=';', Tab='\t'), ',')  
})

output$uploadDataCtrl <- renderUI({
  bsButton("uploadData", label=NULL, type="action", icon=icon("plus"))
})

# CSV download button (for UI)
output$dlBtnCSV <- renderUI({
  downloadButton('dlCSV', 'Download table')
})

output$dlPlotCtrl <- renderUI({
  downloadButton('dlPlotHandler', 'Download')
})

output$dlPlotOpenModalCtrl <- renderUI({
  bsButton("dlPlotOpenModalBtn", label=NULL, type="action", icon=icon("download"))
})

output$fileTypeCtrl <- renderUI({
  selectInput(inputId="fileType", label="File Type", 
              choices=c('PDF'='.pdf', 'PNG'='.png', 'JPG'='.jpg', 'SVG'='.svg'))
})

output$fileHeightCtrl <- renderUI({
  numericInput(inputId="fileHeight", label="Height (inches)", 
               value=getFileDefault()$width, min=0, max=getFileDefault()$heightMax)
})

output$fileWidthCtrl <- renderUI({
  numericInput(inputId="fileWidth", label="Width (inches)", 
              value=getFileDefault()$height, min=0, max=getFileDefault()$widthMax)
})

output$fileDPICtrl <- renderUI({
  numericInput(inputId="fileDPI", label="Dots Per Inch", 
               value=getFileDefault()$DPI, min=0, max=getFileDefault()$DPIMax)
})


output$dbDriverTypeCtrl <- renderUI({
  radioButtons('dbDriverTypeCtrl', 'Driver type', c('MySQL', 'PostgreSQL', 'SQLite'))
})

output$dbExecuteBtn <- renderUI({
  bsButton("dbExecuteBtn", label="Run", icon=icon("play-circle-o"), type="action")
})

#### main ####
datasetName <- reactive({
  input$datasetName
})

plotTypes <- reactive({
  input$plotTypes
})

plotTypesOpts <- reactive({
  reactVals$plotTypeOptsTrigger  # updates using an observer
  isolate({
    reactVals$is_dataset_changed <- F  # to distinguish plotTypes triggers
    getPlotTypeOpts(plotTypes(), length(numericVars()), length(categoricalVars()))
  })
})

x <- reactive({
  input$x
})

yOrig <- reactive({
  input$y
})

y <- reactive({
  ensureProperVarName(colnames(isolate(aggDf())), yOrig(), 
                      isolate(plotAggMeth()), semiAutoAggOn())
})

columns <- reactive({  # for pairsPlot
  input$columns
})

colorOrig <- reactive({
  input$color
})

color <- reactive({
  convertNoneToNULL(ensureProperVarName(
    isolate(colnames(aggLimDf())), colorOrig(), 
            isolate(plotAggMeth()), isolate(semiAutoAggOn())))
})

treatColorAsFactor <- reactive({
  !is.null(input$treatColorAsFactor) && input$treatColorAsFactor
})

fillOrig <- reactive({
  input$fill
})

fill <- reactive({
  convertNoneToNULL(fillOrig())
})

sizeOrig <- reactive({
  input$size
})

size <- reactive({
  convertNoneToNULL(ensureProperVarName(
    isolate(colnames(aggLimDf())), sizeOrig(), 
    isolate(plotAggMeth()), isolate(semiAutoAggOn())))
})

shapeOrig <- reactive({
  input$shape
})

shape <- reactive({
  convertNoneToNULL(shapeOrig())
})

position <- reactive({
  convertNoneToNULL(input$position)
})

jitter <- reactive({
  if (!is.null(input$jitter) && input$jitter) 'jitter' else 'identity'
})

coordFlip <- reactive({
  !is.null(input$coordFlip) && input$coordFlip
})

smoothOrig <- reactive({
  input$smooth
})

smooth <- reactive({
  convertNoneToNULL(input$smooth)
})

alphaOrig <- reactive({
  input$alpha
})

alpha <- reactive({
  if (is.null(alphaOrig())) 1 else alphaOrig()
})

sizeMagOrig <- reactive({
  input$sizeMag
})

sizeMag <- reactive({
  if (is.null(input$sizeMag)) 4 else input$sizeMag
})

nBins <- reactive({
  input$nBins
})

densBlackLine <- reactive({
  input$densBlackLine
})


#### pairs ####
pairsUpCont <- reactive({
  input$pairsUpCont
})

pairsUpCombo <- reactive({
  input$pairsUpCombo
})

pairsUpDiscr <- reactive({
  input$pairsUpDiscr
})

pairsDiagCont <- reactive({
  input$pairsDiagCont
})

pairsDiagDiscr <- reactive({
  input$pairsDiagDiscr
})

pairsLowCont <- reactive({
  input$pairsLowCont
})

pairsLowCombo <- reactive({
  input$pairsLowCombo
})

pairsLowDiscr <- reactive({
  input$pairsLowDiscr
})


#### facets ####
facetRowOrig <- reactive({
  input$facetRow
})

facetRow <- reactive({
  aggLimDf <- aggLimDf()
  if (anyNull(aggLimDf, input$facetRow)) return('.')
  fr <- if (input$facetRow == 'None') '.' else input$facetRow
  if (fr != '.' && fr %in% colnames(aggLimDf)) fr else '.'
})

facetColOrig <- reactive({
  input$facetCol
})

facetCol <- reactive({
  aggLimDf <- aggLimDf()
  if (anyNull(aggLimDf, input$facetCol)) return('.')
  fc <- if (input$facetCol == 'None') '.' else input$facetCol
  if (fc != '.' && fc %in% colnames(aggLimDf)) fc else '.'
}) 

facetWrapOrig <- reactive({
  input$facetWrap
})

facetWrap <- reactive({
  aggLimDf <- aggLimDf()
  if (anyNull(aggLimDf, input$facetWrap)) return('.')
  fw <- ifelse(input$facetWrap=='None', '.', input$facetWrap)
  if (fw != '.' && fw %in% colnames(aggLimDf)) fw else '.'
})

facetScale <- reactive({
  if (is.null(input$facetScale)) 'none' else input$facetScale
})

facetGrids <- reactive({
  row <- facetRow()
  col <- facetCol()
  if (anyNull(row, col)) '. ~ .' else paste(row, '~', col)
})


#### theme ####
plotTitle <- reactive({
  input$plotTitle
})

xLabel <- reactive({
  input$xLabel
})

yLabel <- reactive({
  input$yLabel
})

labelFontFamily <- reactive({
  input$labelFontFamily
})

labelFontFace <- reactive({
  input$labelFontFace
})

labelFontSize <- reactive({
  if (is.null(input$labelFontSize)) 15 else input$labelFontSize
})

labelFontColor <- reactive({
  if (is.null(input$labelFontColor)) 'black' else input$labelFontColor
})

hjust <- reactive({
  if (is.null(input$hjust)) 0.5 else input$hjust
})

vjust <- reactive({
  if (is.null(input$vjust)) 0.5 else input$vjust
})

plotTheme <- reactive({
  if (is.null(input$plotTheme)) 'theme_grey' else input$plotTheme
})


#### aggregations ####
rawVsManAgg <- reactive({
  input$rawVsManAgg
})

plotAggMeth <- reactive({
  if (is.null(input$plotAggMeth)) 'none' else input$plotAggMeth
})

plotAddAggBy <- reactive({
  input$plotAddAggBy
})

dbUploadedDf <- reactive({
  eval_btn <- input$dbExecuteBtn  # trigger
  
  isolate({
    driver_name <- input$dbDriverTypeCtrl
    if (is.null(driver_name) || !eval_btn) return()
    package_for_driver <- paste0('R', driver_name)
    if (!require(package_for_driver, character.only = T)) {
      install.packages(package_for_driver)
      library(package_for_driver, character.only = T)
    }
    
    # con <- dbConnect(dbDriver('MySQL'), user='gray', host='db4free.net',
    #                  password='12348888', dbname='ggtest', port=3307)
    
    con <- dbConnect(dbDriver(driver_name), 
                     host=input$dbHost, port=as.integer(input$dbPort),
                     user=input$dbUser, password=input$dbPass, 
                     dbname=input$dbName)
    
    query <- input$dbSqlQuery
    
    df <- dbGetQuery(con, query)
    df <- df[, setdiff(names(df), 'row_names')]
    dbDisconnect(con)
    
    reactVals$is_db_upload <- T
  })
  
  df
})

# reactive variable for custom (uploaded) dataset
uploadedDf <- reactive({
  # input$file will be NULL initially. After the user selects
  # and uploads a file, it will be a data frame with 'name',
  # 'size', 'type', and 'datapath' columns. The 'datapath'
  # column will contain the local filenames where the data can
  # be found.
  input$file  # trigger
  db_df <- dbUploadedDf()
  
  isolate({
    # to add all dwnload input names at once
    # prevents premature closing of the modal window
    if (sum(c('dbExecuteBtn', 'file') %in% names(input)) == 1) {
      updateTabsetPanel(session, 'addDatasetTabset', 'addFileTab')
    }
    
    close_modal_if_opened <- function() {
      if (input$modalUploadOptions) {
        toggleModal(session, "modalUploadOptions", toggle = "close")
      }
    }
    
    if (not_null_true(reactVals$is_db_upload)) {
      close_modal_if_opened()
      return(db_df)
    }
    if (anyNull(input$file, input$header, input$sep, input$quote)) return()
    
    close_modal_if_opened()
    read.csv(input$file$datapath, header = as.logical(input$header),
             sep = input$sep, quote = input$quote)
  })
})

# reactive variable for custom dataset name
uploadedDfName <- reactive({
  if (is.null(uploadedDf())) return()
  
  isolate({
    if (not_null_true(reactVals$is_db_upload)) {
      reactVals$is_db_upload <- NULL
      
      df_name <- input$dbSqlQuery %>% 
        gsub(' +', ' ',.) %>% 
        stringr::str_extract('(?i)(?<=from )\\S+')
      
      if (is.na(df_name)) 'db_uploaded' else df_name
    } else {
      input$file$name
    }
  })
})


# reactive variable for raw dataset names
rawDatasetNames <- reactive({
  input$evalConsoleBtn  # to update on assignment operation
  unique(c(uploadedDfName(), getInitialArg('initialDfName'), getPreloadedEnvDfNames(), 
           "diamonds", "mtcars", "esoph"))
})


# reactive variable for raw dataset
rawDataset <- reactive({
  nCatUniqVals()  # to update on change of dataset options
  input$evalConsoleBtn  # to update on assignment operation
  cur_name <- datasetName()  # trigger
  if (is.null(cur_name)) return()  # for initial input$datasetName
  
  isolate({
    df <- if (!is.null(uploadedDfName()) && cur_name == uploadedDfName()) 
      uploadedDf() else eval(parse(text = cur_name))
    if (any(class(df) == 'reactive')) {
      stop('Please change the dataset name to prevent a collision with a ggraptR object')
    }
    data.frame(lapply(df, function(x) if (is.character(x)) as.factor(x) else x))
  })
})

# manually aggregated dataset
manAggDataset <- reactive({
  # if all fields for manual aggregation are filled in
  if (notNulls(input$aggBy, input$aggTarget, input$aggMeth)) {
    # return manually aggregated dataset
    aggregate(rawDataset(), input$aggBy, input$aggTarget, input$aggMeth)
  } else {  # return raw dataset  
    rawDataset()
  }
})

# raw or aggregated dataset
dataset <- reactive({
  #if (is.null(input$rawVsManAgg)) return()
  if (is.null(input$rawVsManAgg)) {
    return(rawDataset())
  }
  
  # raw dataset
  if (input$rawVsManAgg == 'raw') {
    rawDataset()
  } else if (input$rawVsManAgg == 'manAgg') {  # aggregated dataset
    manAggDataset()
  }
})


# reactive for base semi-automatic aggregate-by fields 
# (that are NOT in the "additional aggregate-by" fields)
plotSemiAutoAggByBase <- reactive({
  aggBy <- c(input$x, input$color, input$size, input$shape, input$fill, input$facetRow, 
             input$facetCol, input$facetWrap)
  cleanPlotAggBy(input$x, input$y, aggBy)
})

# reactive for semi-automatic aggregate by
# base + additional aggregate-by fields
plotSemiAutoAggBy <- reactive({
  if (is.null(dataset())) return()
  aggBy <- c(plotSemiAutoAggByBase(), plotAddAggBy())
  aggBy <- cleanPlotAggBy(input$x, input$y, aggBy)
  aggBy[aggBy %in% colnames(dataset())]
})

# reactive for semi-automatic aggregated dataset
semiAutoAggDF <- reactive({
  if (is.null(semiAutoAggOn()) || is.null(dataset())) return()
  
  # if plot aggregation is specified (e.g. sum, mean, max, min)  
  if (semiAutoAggOn()) {
    if (is.null(plotSemiAutoAggBy())) {
      return()
    }
    
    aggBy <- plotSemiAutoAggBy()
    aggTarget <- input$y
    aggMeth <- input$plotAggMeth
    
    vars <- c(aggBy, aggTarget)
    if (all(vars %in% colnames(dataset()))) {
      aggregate(dataset(), aggBy=aggBy, aggTarget=input$y, aggMeth=input$plotAggMeth)
    }
  } 
})

# reactive variable for final dataset
aggDf <- reactive({
  if (is.null(dataset())) return()
  if (is.null(semiAutoAggOn())) {
    return(dataset())
  }
  
  # semi-automatic aggregation (if enabled)
  if (semiAutoAggOn()) {
    semiAutoAggDF()
  } else{  # natural dataset (raw or manually aggregated dataset)
    dataset()
  }
})

# filtered version of aggDf() for plotting
# plotAggMeth() -> semiAutoAggOn() -> aggDf() -> .
aggLimDf <- reactive({
  df <- aggDf()
  search_columns <- input$displayTable_search_columns  # input$displayTable_rows_all
  if (is.null(df)) return()
  
  isolate({
    fill_idxs <- if (!is.null(search_columns))
      1:length(search_columns) %>% Filter(function(i) search_columns[i] != '',.) else c()
    if (!length(fill_idxs)) {
      reactVals$plotState$filter <- NULL
      return(df)
    }
    if (tolower(plotAggMeth()) != 'none') {
      stop('Can not choose between aggregated and limited view')
    }
    
    filter_keys <- names(isolate(manAggDataset()))[fill_idxs]
    # search_columns[fill_idxs] ex: "[\"25-34\",\"35-44\"]" "18.18 ... 60.00"
    filter_vals <- lapply(search_columns[fill_idxs], function(x) 
      (if (startsWith(x, '[')) strsplit(substring(x, 2, nchar(x) - 1), ',') else 
        strsplit(x, ' \\.{3} ')) %>% `[[`(1))
    
    reactVals$plotState$filter$keys <- filter_keys
    reactVals$plotState$filter$vals <- filter_vals
    
    df_expr <- applied_filters_expr(df, datasetName(), filter_keys, filter_vals)
    res <- eval(parse(text=df_expr))
    if (!setequal(colnames(df), colnames(res))) {
      stop('Looks like an aggregated and limited view collision')
    }
    res
  })
})

verticalLayout(
  uiOutput('plotTitleCtrl'),
  
  fluidRow(
    column(6, uiOutput('xLabelCtrl')),
    column(6, uiOutput('yLabelCtrl'))),
  
  fluidRow(
    column(6, uiOutput('labelFontFamilyCtrl')),
    column(6, uiOutput('labelFontFaceCtrl'))),
  
  fluidRow(
    column(6, uiOutput('labelFontSizeCtrl')),
    column(6, uiOutput('labelFontColorCtrl'))), 
  
  fluidRow(
    column(6, uiOutput('hjustCtrl')), 
    column(6, uiOutput('vjustCtrl'))),
  
  uiOutput('plotThemeCtrl')
)

pacman::p_load(
  colourpicker, dplyr,DT, futile.logger, GGally, ggplot2, ggthemes, jsonlite, 
  purrr, shiny, shinyBS, shinyjs, stringr, svglite)

# by default, the file size limit is 5MB. 1 Gb = 1024^3 b
options(shiny.maxRequestSize = 10 * 1024^3)

source('globals.R')
source('debug/debug.R', local=T)  # set debug logs
source('functions/helper.R')
sourceAllInDir('functions', except='helper.R')

serverVals <- reactiveValues(nRunnedSessions=0)  # server globals
  
shinyServer(function(input, output, session) {
  reactVals <- reactiveValues(log=NULL, readyToDraw=F, plotState=list()) # session globals
  
  sourceAllInDir('reactives', local=T)  # reactive variables
  sourceAllInDir('uiWidgets', local=T)  # UI controls
  
  output$rappy <- renderImage({
    list(src = "www/RAPPY.png",
         contentType = "image/png", alt = "ggraptR")
    }, deleteFile = FALSE)  
  
  source('observeEvents.R', local=TRUE)
  
  isolate(serverVals$nRunnedSessions <- serverVals$nRunnedSessions + 1)

  session$onSessionEnded(function() {
    isolate({
      serverVals$nRunnedSessions <- serverVals$nRunnedSessions - 1
      if (!serverVals$nRunnedSessions) {
        stopApp()
      }
    })
  })
})

# CSV download handler
output$dlCSV <- downloadHandler(
  filename = function() { 
    ts <- gsub(' |-|:', '', as.character(Sys.time()))
    paste0('output_', ts, '.csv')
  },
  content = function(file) {
    write.csv(manAggDataset(), file, row.names=F)
  }
)

# file output
output$dlPlotHandler <- downloadHandler(
  filename = function() {
    ts <- gsub(' |-|:', '', as.character(Sys.time()))
    paste0('output_', ts, input$fileType)
  },
  content = function(file) {
    # Prepare file parameters for download
    # Local variables assigned because updateNumericInput() execution takes places after
    # the completion of the calling function (ie. the updates will not be made in time for
    # the call to ggsave() and must be resolved locally)
    inputWidth <- input$fileWidth
    inputHeight <- input$fileHeight
    inputDPI <- input$fileDPI
    fileDefault <- getFileDefault()
    
    if (inputWidth < 0 || inputWidth > fileDefault$widthMax 
        || !is.numeric(inputWidth)) {
      updateNumericInput(session, "fileWidth", value=fileDefault$width)
      inputWidth <- fileDefault$width
    }
    if (inputHeight < 0 || inputHeight > fileDefault$heightMax 
        || !is.numeric(inputHeight)) {
      updateNumericInput(session, "fileHeight", value=fileDefault$height)
      inputHeight <- fileDefault$height
    }
    if (inputDPI < 0 || inputDPI > fileDefault$DPIMax || !is.numeric(inputDPI)) {
      updateNumericInput(session, "fileDPI", value=fileDefault$DPI)
      inputHeight <- fileDefault$DPI
    }
    
    if (plotTypes() == 'pairs') {
      dev <- ggplot2:::plot_dev(NULL, file, inputDPI)
      dev(file=file, width=inputWidth, height=inputHeight)
      print(buildPlot())
      dev.off()
    } else
      ggsave(file, plot=buildPlot(), width=inputWidth, height=inputHeight, 
           units="in", dpi=inputDPI)
  }
)

# register the final dataset to be used upon AJAX call from UI
action <- reactive({DT::dataTableAjax(session, aggDf())})

# aggregation-by options
output$aggByCtrl <- renderUI({
  selectInput('aggBy', 'Aggregate By', choices=colnames(rawDataset()), multiple=T)
})

# aggregation target options
output$aggTargetCtrl <- renderUI({
  selectInput('aggTarget', 'Aggregation Target', 
              setdiff(getIsNumericVarNames(rawDataset()), input$aggBy), 
              multiple=T)
})

# aggregation method options
output$aggMethCtrl <- renderUI({
  aggMethOpts <- c('mean', 'sum', 'count', 'min', 'max', 'median')
  selectInput('aggMeth', 'Aggregation Method', choices=aggMethOpts, multiple=T)
})

#### main ####
displayXCond <- reactive({
  'x' %in% plotInputs()
})

displayYCond <- reactive({
  # y() exists only when x(). y options must be different from selected x value 
  # so it does not make sense to render y before x is ready
  displayXCond() && !is.null(x()) && 'y' %in% plotInputs()
})

displayGgpairsColumnsCond <- reactive({
  'pairs' %in% plotTypes()
})

displayColorCond <- reactive({
  'color' %in% plotInputs()
})

displayTreatAsFactorCond <- reactive({
  'treatColorAsFactor' %in% plotInputs() && 
    !is.null(color()) && color() %in% isolate(numericVars())
})

displayFillCond <- reactive({
  'fill' %in% plotInputs()
})

displaySizeCond <- reactive({
  'size' %in% plotInputs()
})

displayShapeCond <- reactive({
  'shape' %in% plotInputs()
})

displayPositionCond <- reactive({
  'position' %in% plotInputs() && !is.null(fill())
})

displayJitterCond <- reactive({
  'jitter' %in% plotInputs()
})

displayCoordFlipCond <- reactive({
  displayXCond() && !'pairs' %in% isolate(plotTypes())
})

displaySmthCond <- reactive({
  'smooth' %in% plotInputs()
})

displayAlphaCond <- reactive({
  'alpha' %in% plotInputs()
})

displaySizeMagCond <- reactive({
  'sizeMag' %in% plotInputs() && is.null(size())
})

displayBinsCond <- reactive({
  'nBins' %in% plotInputs()
})

displayDensBlackLineCond <- reactive({
  'densBlackLine' %in% plotInputs()
})


#### pairs ####
displayGgpairsCond <- reactive({
  displayGgpairsColumnsCond()
})


#### facet ####
displayFacetCond <- reactive({
  is.null(plotTypes()) || !'pairs' %in% plotTypes()
})


#### theme ####
# displayTitlesCond <- reactive({
#   !is.null(input$reactive) && !input$reactive 
# })

---
title: "ggraptR"
author: "Jason Widjaja"
date: "`r Sys.Date()`"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{ggraptR}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---
```{r, include = FALSE}
knitr::opts_chunk$set(collapse = TRUE, comment = "#>")
library(ggraptR)
```

# ggraptR: Rapid And Pretty Things in R

## A Flexible Interface for Data Visualisation and Analysis

This vignette provides a guide to the ggraptR package. It describes the situations where the package can be applied and provides context in terms of package design and application. It also provides examples of the package in action.  

## Overview
ggraptR is an open source R package providing a graphical user interface for data exploration and visualisation. It is based on principles of visualization analysis by Tamara Munzner, and also acts as a wrapper for functionality implemented in the grammar of graphics for R, ggplot2.

ggplot2 offers a wide array of marks and channels that constitute the building blocks for developing visual encodings, as well as a large selection of built-in visual idioms. However, users unfamiliar with the package may not have visibility of the options available to them, or find it challenging to express their envisioned design in their desired visual idiom.
 
ggraptR is designed to handle a spectrum of data visualisation needs ranging from visualising the raw values of individual variables through to fully aggregated, pivot-table style visualisations. Data volume and visual complexity is handled by the implementation of two approaches to handle visual complexity - faceting into multiple views, and reduction of items and attributes.

## Workflow

The standard workflow in ggraptR consists of

1. Importing data (from an R dataset or a flat file)
2. Producing and customisation a data visualisation using the Plot toolbar
3. Exporting the completed visualisation as an image file

### Reactivity and large data sets

![alt text](ggraptR_5_submit.png "Reactivity")

By default, the visualisation refreshes whenever there is a change to the dataset or any input control.

However, when dealing with large datasets that take awhile to render it may be advantageous to only generate the visualisation once multiple controls have been tweaked. In this case, the 'Enable reactivity' checkbox should be unchecked, and multiple changes can be made before clicking on the 'Submit' button.

## 1. Importing Data

There are two options for importing data. The preferred way is to load a dataset into a data frame within the R environment. All loaded data frames will be available to ggraptR when ggraptR is launched. 

To check which data frames are available, click on the dropdown underneath 'Choose a dataset'. A number of pre-loaded datasets along with any data frames within the R environment should be shown. For users of RStudio, these can be found under the environment tab (next to history and build). 

If your data is present in the environment and not in ggraptR, you should confirm if the data type is data frame using the command:

```
class(my_data_frame)
```

where 'my_data_frame' is the name of your data. 

If it is not of type "data.frame" then you can coerce it using

```{r eval=FALSE}
data_frame_name <- as.data.frame(my_data_frame)
```

where 'my_data_frame' is the name of your data and 'data_frame_name' is the name of your data when saved into a data frame format. 

To load a csv file into a new data frame, read data in csv format using the read.csv command:

```{r eval=FALSE}
data_frame_name <- read.csv("data_to_be_imported.csv")
```

where 'data_frame_name' is your preferred name for the dataset to be loaded and 'data_to_be_imported' is the name of the csv file containing the dataset. The csv file should be located in the working directory.

Alternatively, you may import a dataset, by clicking on the import tab as shown:

![alt text](ggraptR_import.png "Import a file")

Click 'choose file', and select the required file. 

If the first row of the file contains header names, make sure the checkbox next to 'Header' is ticked.

Choose the appropriate Quote and Separator buttons depending how quotes and delimiters are used in the flat file. 

Note that the options default to a header, double quote and comma separated variables (CSV). 

Once the file is uploaded, an 'Upload complete' bar will be shown. The dataset will immediately become available in the 'Choose a dataset' dropdown.

## 2. Data Explorer Toolbar

The toolbar has four sections:

1. Choosing a dataset
2. Basic plotting (single visualisation)
3. Advanced visual encoding (aesthetics and themes, faceting, zoom-in)
4. Aggregation

### 2.1 Choosing a dataset

To choose a dataset for visualiastion, select a dataset from the 'Choose a dataset' dropdown. You should see a number of pre-loaded R datasets along with any active data frames in your environments and  the most recent file you uploaded.

### 2.2 Basic Plotting

To plot raw data, simply:

* Select a dataset
* Select a plot type (aka visual idiom)
* Select data attributes for the X axis and Y axis

Please refer to Appendix A further down this page for recommendations for the use of individual visual idioms.


### 2.3 Advanced visual encoding

#### 2.3.1 Aesthetics and Themes

Click on the 'Show aesthetics' box to explore a number of options to improve plot aesthetics, or the 'Show themes' box to customise plot label aesthetics.

'Show aesthetics' reveals the following controls:

* Additional attributes can be selected for encoding via other visual channels (colour, size and shape)
* Opacity and point size can be adjusted
* Jitter effects can be applied to facilitate visual analysis

Note: The 'jitter' effect is often used to enhance visual interpretability when dealing with a larger data sets with many overlapping data points. In this case, jittering would reveal the relative density of points around each overlapping data point.

![alt text](ggraptR_31_jitter.png "Jitter options")

If data appears cluttered or overly spaced out in the plot, check the 'Flip X and Y coordinates' box to explore swapping axes. 

'Show themes' reveals the following controls:

* Axis font labels and positioning can be adjusted
* Built-in themes can be used as a starting point for further customisation

![alt text](ggraptR_34_themes.png "Themes")

Note that the "Enable reactivity" checkbox needs to be disabled in order to edit the axes labels and plot title.

#### 2.3.2 Faceting

Click on the 'Show facets' check box to display controls for presenting a multi-plot data visualisation. 

![alt text](ggraptR_32_facets.png "Faceting controls")

There are two faceting alternatives available to users:

* Use the facet row and/or facet column dropdowns to select variables to build multiple visualisations , OR 
* Use the facet wrap dropdown to direct the package to automatically select an optimal number of rows and columns that will seek to preserve the dimensions of the original plot.

The differences are shown below:

![alt text](ggraptR_32_facetoptions.png "Facet Options")

Optionally, the facet scale functionality allows the DE the freedom to re-scale the X-axis and/or Y-axis within each facet grid.

This is useful to improve visual clarity if the relative values of data attributes do not make good use of the visualisation space. However, caution should be taken as this may lead to misleading interpretations for the casual observer who misses the different scales used.


#### 2.3.3 Zoom-in

Click on the 'Show filtering' check box to display controls for zooming in on a subset of the plot. 

![alt text](ggraptR_33_ranges.png "Zoom-in")

The two sliders can be dragged to restrict the range of the data shown. The visualisation area will scale so that the subsetted range will be shown over the full area.

An example of this control in action is shown below:

![alt text](ggraptR_33b_ranges.png "Range restrictions")

#### 2.4 Aggregation

Aggregation controls are used to simulate pivot chart functionality. 

To plot aggregated measures of data, check the 'Show dataset type and aggregation method' box. 

The 'Dataset Type' dropdown can be ignored.

Select the desired aggregation method from the dropdown menu.

![alt text](ggraptR_4_aggregate.png "Aggregation method")

The aggregation contol applies a function to transform raw data into count data or calculated values. 

![alt text](ggraptR_42_aggregatecompare.png "Aggregation method")

## 3. Export Plot

Once the visualisation is complete, click on 'Export Plot' to save the visualisation. The 'Export Options' dialogue box will appear.

![alt text](ggraptR_6_export.png "Export options")

Select the dimensions and file type for the exported file and click 'Download' to save it to your local machine. 

*Known issue: Machines running on Windows may not be able to save plots if they are running ggraptR from RStudio. If this is the case, click 'Open in Browser' to enable export functionality.*

*Known issue: The Export Options dialogue box may not appear for machines running on Windows. However the file can still be saved using the workaround above.*

# Worked Examples

To see the functionality working in unison, the following are two examples. 

Example 1: Faceted boxplots

* Choose the dataset diamonds
* Select Box plot
* Select Cut as the X axis
* Select Price as the Y axis
* Click the 'Show aesthetics' checkbox
* Select Colour as the fill
* Click the 'Show facets' checkbox
* Select Clarity under 'Facet Column'
* Click 'Flip X and Y coordinates'

![alt text](ggraptR_7_combine2.png "Example 1")

Example 2: Faceted boxplots

* Choose the dataset mtcars
* Select Density plot
* Select mpg (miles per gallon) as the X axis
* Click the 'Show aesthetics' checkbox
* Select cyl (number of cylinders) as the fill
* Click the 'Show facets' checkbox
* Select am (automatic/manual) under 'Facet Column'
* Set transparency to 0.5

![alt text](ggraptR_7_combine3.png "Example 2")

### Questions and issues

This vignette was authored by Jason Widjaja and Eugene Dubossarsky. Any questions and issues may be directed to : eugene@presciient.com

### Appendix A: Guide to Visual Idiom Choices


Idiom:         | Scatterplots
-------------  | ------------ 
Data:          | Two quantitative value attributes   
Encoding:      | Express values with horizontal and vertical spatial position and point marks
Task:          | Find trends, outliers, distribution, correlation; locate clusters
Scale          | Hundreds of items



Idiom:         | Bar Charts
-------------  | ------------ 
Data:          | One quantitative value attributes, one categorical key attribute
Encoding:      | Express value attribute with aligned vertical position, separate key attribute with horizonal position
Task:          | Lookup and compare values
Scale          | Dozens to hundreds of levels


Idiom:         | Stacked Bar Charts
-------------  | ------------ 
Data:          | Multidimensional table: one quantitative value attributes, two categorical key attributes
Encoding:      | Bar with length-coded subcomponents of value attribute for each category of secondary key attribute. Separate bars by category of primary key attribute.
Task:          | Part-to-whole relationship, lookup values, find trends
Scale          | Main axis: Dozens to hundreds of levels. Stacks: Several to one dozen 


Idiom:         | Line Charts
-------------  | ------------ 
Data:          | One quantitative value attribute, one ordered key attribute
Encoding:      | Dot chart with connection marks between dots 
Task:          | Show trends
Scale          | Hundreds of levels


Idiom:         | Scatterplot Matrix (SPLOM)
-------------  | ------------ 
Data:          | Two quantitative value attributes for each plot, one categoric variable for row facet and one categoric variable for column facet
Encoding:      | Scatterplots in 2D matrix alignment
Task:          | Find correlation, trends, outliers
Scale          | Attributes: one dozen. Items: dozens to hundreds
